
<script>


/*
	json-tree-view-vue3
	
	https://github.com/cloydlau/json-editor-vue
	
	https://www.npmjs.com/package/pretty-print-json
*/
import 'vanilla-jsoneditor/themes/jse-theme-dark.css'


import { lap } from '@/fleet/lap'

import { furnish_string } from 'procedures/furnish/string'

import JsonEditorVue from 'json-editor-vue'

export default {
	components: {
		JsonEditorVue
	},
	
	props: {
		name: "",
		fields: {}
	},
	
	data () {
		return {
			fields_inputs: this.fields,
			proceeds_fields: {}
		}
	},
	
	watch: {
		name () {
			this.fields_inputs = {}
			this.proceeds_fields = {}
		}
	},
	
	methods: {
		async move () {
			const proceeds = await lap ({
				envelope: {
					name: this.name,
					fields: this.fields_inputs
				}
			});
			if (proceeds.status !== "pass") { 
				const note = furnish_string (proceeds, [ 'note' ], 'A failure occurred without details.')
				this.$vaToast.init ({ message: note, color: 'danger' })
				return;
			}
			
			const note = furnish_string (proceeds, [ 'note' ], 'A pass occurred without details.')
			this.$vaToast.init ({ message: note, color: 'success' })
			
			this.proceeds_fields = proceeds.fields;
		}
	}
}

</script>



<template>
	<div>
		<h1>{{ name }}</h1>
	
		<VaButton
			@click="move"
			color="#000"
			textColor="#FFF"
		>move</VaButton>
	
		<div
			:style="{
				color: 'white',
				
				background: 'linear-gradient(45deg, #8000805c, #513b4f, #77281645, #97975400)',
				border: '2px solid #9b3f9163',
				
				
				padding: '.1in',
				
				borderRadius: '10px',
				
				marginTop: '10px'
			}"		
		>
			<h2>fields</h2>
			<JsonEditorVue
				class="jse-theme-dark"
				v-model="fields_inputs"
			/>
		</div>
	
		<div
			:style="{
				color: 'white',
				
				background: 'linear-gradient(45deg, #8000805c, #513b4f, #77281645, #97975400)',
				border: '2px solid #9b3f9163',
				
				
				padding: '.1in',
				
				borderRadius: '10px',
				
				marginTop: '10px'
			}"		
		>
			<JsonEditorVue
				class="jse-theme-dark"
				v-model="proceeds_fields"
			/>
		</div>
	
	</div>
</template>


